Index: trunk/kernel/libk/htab.h
===================================================================
--- trunk/kernel/libk/htab.h	(revision 690)
+++ trunk/kernel/libk/htab.h	(revision 1)
@@ -2,5 +2,7 @@
  * htab.h - Generic embedded hash table definition.
  * 
- * Authors  Alain Greiner (2016,2017,2018)
+ * Author     Ghassan Almalles (2008,2009,2010,2011,2012)
+ *            Mohamed Lamine Karaoui (2015)
+ *            Alain Greiner (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -26,98 +28,89 @@
 #define _HTAB_H_
 
-#include <hal_kernel_types.h>
-#include <rwlock.h>
+#include <hal_types.h>
 #include <list.h>
 
-/////////////////////////////////////////////////////////////////////////////////////////
-// This file define a generic, embedded, local hash table.
-//
-// It can only be accessed by threads running in the local cluster.
-// It is generic as it can be used to register various types of items.
-// The main goal is to provide fast retrieval for a large number of items of same type.
-// For this purpose the set of all registered items is split in several subsets. 
-// Each subset is organised as a double linked lists.
-// - an item is uniquely identified by a <key>, that can be a single uint32_t, 
-//   a character string, or a more complex structure.
-// - From the pointer on <key>, we use an item type specific htab_index() function,
-//   to compute an <index> value, defining a subset of registered items.
-// - As several items can have the same <index>, we use the item type specific 
-//   htab_scan() function for a final associative search on the subset.
-// - Each registered item is a structure, that must contain an embedded list_entry_t,
-//   that is part of a rooted double linked list.
-//
-// Implementation Note: for each supported item type ***, you must define the two
-//                      htab_***_index() and htab_***_scan() functions, and
-//                      update the htab_init() function.
-/////////////////////////////////////////////////////////////////////////////////////////
-
-#define HASHTAB_SIZE    64   // number of subsets
+/****************************************************************************************
+ * This file define a generic, embedded, hash table.
+ * The main goal is to provide fast retrieval for a large number of items of same type
+ * in a given cluster. For this purpose the set of all registered items is split
+ * in several subsets. Each subset is organised as a double linked lists.
+ * - an item is uniquely identified by a <key>, that can be a single uint32_t, 
+ *   a character string, or a more complex structure.
+ * - From the pointer on the <key>, the hash table uses an user defined ht_hash() 
+ *   function, to compute an <index> value, defining a subset of registered
+ *   items, to restrict the associative search.
+ * - As several items can have the same <index>, the hash table uses the user defined
+ *   ht_compare() function for a final associative search on the subset.
+ * - Each registered item is a structure, that must contain an embedded ht_node_t,
+ *   This ht_node_t is part of a rooted double linked list, and contains the <index>.
+ * - Finally, the hash table returns a pointer on the embedded ht_node_t, and the
+ *   pointer on the searched item can be obtained by a simple offset.
+ ***************************************************************************************/
 
 /****************************************************************************************
- * These typedef define the two item type specific function prototypes.
+ * This define the generic, user defined, function types.
  ***************************************************************************************/
 
-struct htab_s;
+struct ht_node_s;
 
-typedef void *     htab_scan_t( struct htab_s * htab , uint32_t index , void * key );
-
-typedef uint32_t   htab_index_t( void * key );
+typedef bool_t     ht_compare_t( struct ht_node_s * node , void * key );
+typedef uint32_t   ht_hash_t( void * key );
 
 /****************************************************************************************
- * This define the supported item types.
+ * This structure defines the hash table header.
  ***************************************************************************************/
 
-typedef enum
+typedef struct ht_header_s
 {
-    HTAB_BLOUP_TYPE = 1,                     /*! item is a bloup_t                     */
+	uint32_t        nb_buckets;   /*! number of subsets (one linked list per subset)   */
+	ht_hash_t     * hash;         /*! user defined hash function                       */ 
+	ht_compare_t  * compare;      /*! user defined compare function                    */
+	list_entry_t  * buckets;      /*! array of root of partial lists of ht_node_t      */
 }
-htab_item_type_t;
+ht_header_t;
 
 /****************************************************************************************
- * This structure defines the the root of a local hash table.
+ * This structure defines one hash table node.
  ***************************************************************************************/
 
-typedef struct htab_s
+typedef struct ht_node_s
 {
-	list_entry_t      roots[HASHTAB_SIZE];  /*! array of roots of partial lists        */
-	htab_index_t    * index;                /*! item type  specific function           */
-	htab_scan_t     * scan;                 /*! item type specific function            */
-    uint32_t          items;                /*! number of registered items             */
-    busylock_t        lock;                 /*! lock protecting hash table accesses    */
+	uint32_t     index;           /*! integer value computed from the key              */
+	list_entry_t list;	          /*! member of list of all nodes in same bucket       */
 }
-htab_t;
+ht_node_t;
 
 /****************************************************************************************
- * This function initialises an empty hash table (zero registered item).
+ * This function initialises one hash table node.
  ****************************************************************************************
- * @ htab       : pointer on hash table.
- * @ type       : item type.
+ccccc
  ***************************************************************************************/
-void htab_init( htab_t           * htab,
-                htab_item_type_t   type );
+void ht_node_init( ht_node_t * node );
 
 /****************************************************************************************
- * This function register a new item in the hash table.
+ * This function allocates memory for the buckets array, and initializes the header.
+ * The number of buckets (number of subsets) is PAGE_SIZE / sizeof(list_entry_t)
  ****************************************************************************************
- * @ htab       : pointer on the hash table.
- * @ key        : pointer on the item identifier.
- * @ list_entry : pointer on list_entry_t embedded in item to be registered.
- * @ return 0 if success / return EINVAL if item already registered.
+ * @ header     : pointer on the hash table header.
+ * @ ht_hash    : pointer on the user defined hash function.
+ * @ ht_compare : pointer on the user defined compare function.
+ * @ return 0 if success / return ENOMEM if error.
  ***************************************************************************************/
-error_t htab_insert( htab_t       * htab,
-                     void         * key,
-                     list_entry_t * list_entry );
+error_t ht_header_init( ht_header_t  * header,
+                        ht_hash_t    * ht_hash,
+                        ht_compare_t * ht_compare );
 
 /****************************************************************************************
- * This function remove an item from the hash table.
+ * This function register a new node in the hash table.
  ****************************************************************************************
- * @ header     : pointer on the hash table.
+ * @ header     : pointer on the hash table header.
+ * @ node       : pointer on the node to be registered (embedded in item).
  * @ key        : pointer on the item identifier.
- * @ list_entry : pointer on list_entry_t embedded in item to be removed.
- * @ return 0 if success / return EINVAL if item not found.
+ * @ return 0 if success / return EINVAL if node already registered...
  ***************************************************************************************/
-error_t htab_remove( htab_t       * htab,
-                     void         * key,
-                     list_entry_t * list_entry );
+error_t ht_insert( ht_header_t * header,
+                   ht_node_t   * node,
+                   void        * key );
 
 /****************************************************************************************
@@ -125,11 +118,20 @@
  * identified by its key.
  ****************************************************************************************
- * @ htab      : pointer on the hash table.
- * @ key       : pointer on the item identifier.
- * @ return pointer on item if found / return NULL if not found.
+ * @ header     : pointer on the hash table header.
+ * @ key        : pointer on the item identifier.
+ * @ return pointer on node if found / return NULL if not found.
  ***************************************************************************************/
-void * htab_lookup( htab_t * htab,
-                    void   * key);
+ht_node_t * ht_find( ht_header_t * header,
+                     void        * key);
 
+/****************************************************************************************
+ * This function remove an item from the hash table.
+ ****************************************************************************************
+ * @ header     : pointer on the hash table header.
+ * @ key        : pointer on the item identifier.
+ * @ return 0 if success / return EINVAL if not found.
+ ***************************************************************************************/
+error_t ht_remove( ht_header_t * header,
+                   void        * key );
 
-#endif /* _HTAB_H_ */
+#endif /* _HTABLE_H_ */
Index: trunk/kernel/libk/iprintk.c
===================================================================
--- trunk/kernel/libk/iprintk.c	(revision 1)
+++ trunk/kernel/libk/iprintk.c	(revision 1)
@@ -0,0 +1,266 @@
+/*
+   This file is part of MutekP.
+
+   MutekP is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+
+   MutekP is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with MutekP; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+
+   UPMC / LIP6 / SOC (c) 2007
+   */
+
+/* 
+   revision 1.2.2 2011/07/12 11:08:34 Ghassan
+   - Split main loop into 3 noinline functions: compute_dec32, compute_dec64, compute_hex 
+   - Use bigger buffer size
+   - Reuse buffer treatment
+   - Add 64 bits support
+   - Add char count;
+
+   revision 1.2.1 2007/11/11 18:54:23 Ghassan
+   rename iprintf to __iprintk, it's a copy of iprintf called on system level.
+
+   stdio of the ghost of libc
+   Developped by Denis Hommais and Frédéric Pétrot
+   $Log: iprintf.c,v $
+   Revision 1.2  2003/07/01 13:40:46  fred
+   Supports the %u and doesnt core anymore on an unrecognized char
+   following a %
+
+   Revision 1.1.1.1  2002/02/28 12:58:56  disydent
+   Creation of Disydent CVS Tree
+
+   Revision 1.1  2001/11/22 15:07:36  fred
+   Adding the iprintf function that does the formatting, and removes all
+   the old stuff hanging around.
+
+   $Id: iprintf.c,v 1.2 2003/07/01 13:40:46 fred Exp $
+   Made up this file to centralize the printf behavior
+   */
+
+#include <remote_access.h>
+#include <stdarg.h>
+#include <types.h>
+#include <libk.h>
+
+/* Handling of the printf internals
+ * Addr is either the buffer or the tty addrs
+ * inc is 0 for a tty and 1 for a buffer
+ * Other arguments are self explanatory
+ */
+
+#define SIZE_OF_BUF 20
+
+char* __attribute__((noinline)) compute_dec64(char **addr,
+		uint_t cid,
+		char *buf,
+		uint_t *len,
+		int inc, 
+		uint64_t val, 
+		bool_t isSigned)
+{
+	register int64_t sval;
+	register uint32_t uval;
+	register char *tmp;
+	register uint_t count;
+	register uint_t i;
+
+	if(isSigned == true)
+	{
+		sval = val;
+		if(sval < 0)
+		{
+			sval = -sval;
+			val = sval;
+			remote_sb((void*)*addr, cid, '-');
+			*len = *len + 1;
+			(*addr) += inc;
+		}
+	}
+
+	count = 0;
+	i = 0;
+	tmp = buf + SIZE_OF_BUF;
+	*--tmp = '\0';
+
+	while(val >= 1000000000UL)
+	{
+		val -= 1000000000UL;
+		count ++;
+	}
+
+	uval = (uint32_t) val;
+
+	do
+	{
+		*--tmp = (uval % 10) + '0';
+		uval /= 10;
+		i++;
+	}while((uval) || (i < 9));
+
+	uval = count;
+
+	do
+	{
+		*--tmp = (uval % 10) + '0';
+		uval /= 10;
+	}while(uval);
+
+	return tmp;
+}
+
+static char* __attribute__((noinline)) compute_dec(char **addr,
+		uint_t cid,
+		char *buf,
+		uint_t *len,
+		int inc, 
+		uint_t val, 
+		bool_t isSigned)
+{
+	register sint_t sval;
+	register char *tmp;
+
+	if(isSigned == true)
+	{
+		sval = val;
+		if(sval < 0)
+		{
+			sval = -sval;
+			val = sval;
+			remote_sb(*addr, cid, '-');
+			*len = *len + 1;
+			(*addr) += inc;
+		}
+	}
+
+	tmp = buf + SIZE_OF_BUF;
+	*--tmp = '\0';
+
+	do
+	{
+		*--tmp = (val % 10) + '0';
+		val /= 10;
+	}while (val);
+
+	return tmp;
+}
+
+static char* __attribute__((noinline)) compute_hex(char **addr, 
+		uint_t cid,
+		char *buf, 
+		uint_t val, 
+		bool_t isPointer)
+{
+	register char *tmp;
+	register char *xdigit;
+	register uint_t i;
+
+	i = 0;
+	xdigit = "0123456789abcdef";
+	tmp = buf + SIZE_OF_BUF;
+	*--tmp = '\0';
+
+	do
+	{
+		*--tmp = xdigit[val & 15];
+		val = val >> 4;
+		i++;
+	}while (val);
+
+	if(isPointer)
+	{
+		while (i < 8)
+		{
+			*--tmp = xdigit[0];
+			i++;
+		}
+	}
+
+	return tmp;
+}
+
+int iprintk (char *addr, uint_t cid, int inc, const char *fmt, va_list ap)
+{
+	char *tmp;
+	sint_t val;
+	uint_t uval;
+	uint64_t val64;
+	uint_t count = 0;
+	char buf[SIZE_OF_BUF];
+
+	while (*fmt)
+	{
+		while ((*fmt != '%') && (*fmt))
+		{
+			remote_sb(addr, cid, *fmt++);
+			addr += inc;
+			count++;
+		}
+		if (*fmt)
+		{
+			fmt++;
+			switch (*fmt)
+			{
+				case '%':
+					remote_sb(addr, cid, '%');
+					addr += inc;
+					count++;
+					goto next;
+				case 'c':
+					remote_sb(addr, cid, va_arg (ap, uint_t));
+					addr += inc;
+					count++;
+					goto next;
+				case 'd':
+					val = va_arg (ap, sint_t);
+					tmp = compute_dec(&addr, cid, &buf[0], &count, inc, val, true); 
+					break;
+				case 'u':
+					uval = va_arg (ap, uint_t);
+					tmp = compute_dec(&addr, cid, &buf[0], &count, inc, uval, false); 
+					break;
+				case 'D':
+					val64 = va_arg (ap, int64_t);
+					tmp = compute_dec64(&addr, cid, &buf[0], &count, inc, val64, true); 
+					break;
+				case 'U':
+					val64 = va_arg (ap, uint64_t);
+					tmp = compute_dec64(&addr, cid, &buf[0], &count, inc, val64, false); 
+					break;
+				case 's':
+					tmp = va_arg (ap, char *);
+					if (!tmp)
+						tmp = "empty str";
+					break;
+				case 'p':
+				case 'x':
+					uval = va_arg (ap, uint_t);
+					tmp = compute_hex(&addr, cid, &buf[0], uval, (*fmt == 'p') ? true : false);
+					break;
+				default:
+					remote_sb(addr, cid, *fmt);
+					count++;
+					goto next;
+			}
+			while (*tmp)
+			{
+				remote_sb(addr, cid, *tmp++);
+				addr += inc;
+				count++;
+			}
+next:
+			fmt++;
+		}
+	}
+	va_end (ap);
+	return count;
+}
Index: trunk/kernel/libk/iprintk.c.bak
===================================================================
--- trunk/kernel/libk/iprintk.c.bak	(revision 1)
+++ trunk/kernel/libk/iprintk.c.bak	(revision 1)
@@ -0,0 +1,259 @@
+/*
+   This file is part of MutekP.
+  
+   MutekP is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+  
+   MutekP is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+  
+   You should have received a copy of the GNU General Public License
+   along with MutekP; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+  
+   UPMC / LIP6 / SOC (c) 2007
+*/
+
+/* 
+   revision 1.2.2 2011/07/12 11:08:34 Ghassan
+    - Split main loop into 3 noinline functions: compute_dec32, compute_dec64, compute_hex 
+    - Use bigger buffer size
+    - Reuse buffer treatment
+    - Add 64 bits support
+    - Add char count;
+    
+   revision 1.2.1 2007/11/11 18:54:23 Ghassan
+   rename iprintf to __iprintk, it's a copy of iprintf called on system level.
+   
+   stdio of the ghost of libc
+   Developped by Denis Hommais and Frédéric Pétrot
+   $Log: iprintf.c,v $
+   Revision 1.2  2003/07/01 13:40:46  fred
+   Supports the %u and doesnt core anymore on an unrecognized char
+   following a %
+  
+   Revision 1.1.1.1  2002/02/28 12:58:56  disydent
+   Creation of Disydent CVS Tree
+  
+   Revision 1.1  2001/11/22 15:07:36  fred
+   Adding the iprintf function that does the formatting, and removes all
+   the old stuff hanging around.
+  
+   $Id: iprintf.c,v 1.2 2003/07/01 13:40:46 fred Exp $
+   Made up this file to centralize the printf behavior
+*/
+
+#include <stdarg.h>
+#include <types.h>
+#include <libk.h>
+
+/* Handling of the printf internals
+ * Addr is either the buffer or the tty addrs
+ * inc is 0 for a tty and 1 for a buffer
+ * Other arguments are self explanatory
+ */
+
+#define SIZE_OF_BUF 20
+
+static char* __attribute__((noinline)) compute_dec64(char **addr,
+						     char *buf, 
+						     int inc, 
+						     uint64_t val, 
+						     bool_t isSigned)
+{
+  register int64_t sval;
+  register uint32_t uval;
+  register char *tmp;
+  register uint_t count;
+  register uint_t i;
+
+  if(isSigned == true)
+  {
+    sval = val;
+    if(sval < 0)
+    {
+      sval = -sval;
+      val = sval;
+      **addr = '-';
+      (*addr) += inc;
+    }
+  }
+
+  count = 0;
+  i = 0;
+  tmp = buf + SIZE_OF_BUF;
+  *--tmp = '\0';
+  
+  while(val >= 1000000000UL)
+  {
+    val -= 1000000000UL;
+    count ++;
+  }
+
+  uval = (uint32_t) val;
+
+  do
+  {
+    *--tmp = (uval % 10) + '0';
+    uval /= 10;
+    i++;
+  }while((uval) || (i < 9));
+  
+  uval = count;
+
+  do
+  {
+    *--tmp = (uval % 10) + '0';
+    uval /= 10;
+  }while(uval);
+
+  return tmp;
+}
+
+static char* __attribute__((noinline)) compute_dec(char **addr,
+						   char *buf, 
+						   int inc, 
+						   uint_t val, 
+						   bool_t isSigned)
+{
+  register sint_t sval;
+  register char *tmp;
+
+  if(isSigned == true)
+  {
+    sval = val;
+    if(sval < 0)
+    {
+      sval = -sval;
+      val = sval;
+      **addr = '-';
+      (*addr) += inc;
+    }
+  }
+
+  tmp = buf + SIZE_OF_BUF;
+  *--tmp = '\0';
+
+  do
+  {
+    *--tmp = (val % 10) + '0';
+    val /= 10;
+  }while (val);
+
+  return tmp;
+}
+
+static char* __attribute__((noinline)) compute_hex(char **addr, 
+						   char *buf, 
+						   uint_t val, 
+						   bool_t isPointer)
+{
+  register char *tmp;
+  register char *xdigit;
+  register uint_t i;
+
+  i = 0;
+  xdigit = "0123456789abcdef";
+  tmp = buf + SIZE_OF_BUF;
+  *--tmp = '\0';
+
+  do
+  {
+    *--tmp = xdigit[val & 15];
+    val = val >> 4;
+    i++;
+  }while (val);
+
+  if(isPointer)
+  {
+    while (i < 8)
+    {
+      *--tmp = xdigit[0];
+      i++;
+    }
+  }
+
+  return tmp;
+}
+
+int iprintk (char *addr, int inc, const char *fmt, va_list ap)
+{
+   char *tmp;
+   sint_t val;
+   uint_t uval;
+   uint_t count = 0;
+   char buf[SIZE_OF_BUF];
+
+   while (*fmt)
+   {
+      while ((*fmt != '%') && (*fmt))
+      {
+	*addr = *fmt++;
+         addr += inc;
+         count++;
+      }
+      if (*fmt)
+      {
+         fmt++;
+         switch (*fmt)
+         {
+         case '%':
+            *addr = '%';
+            addr += inc;
+            count++;
+            goto next;
+         case 'c':
+            *addr = va_arg (ap, uint_t);
+            addr += inc;
+            count++;
+            goto next;
+         case 'd':
+	    count ++;
+	    val = va_arg (ap, sint_t);
+	    tmp = compute_dec(&addr, &buf[0], inc, val, true); 
+            break;
+         case 'u':
+	    uval = va_arg (ap, uint_t);
+	    tmp = compute_dec(&addr, &buf[0], inc, uval, false); 
+            break;
+	 case 'D':
+	    count ++;
+	    val = va_arg (ap, int64_t);
+	    tmp = compute_dec64(&addr, &buf[0], inc, val, true); 
+	    break;
+	 case 'U':
+            uval = va_arg (ap, uint64_t);
+	    tmp = compute_dec64(&addr, &buf[0], inc, uval, false); 
+            break;
+         case 's':
+	    tmp = va_arg (ap, char *);
+            if (!tmp)
+               tmp = "empty str";
+            break;
+         case 'p':
+         case 'x':
+	   uval = va_arg (ap, uint_t);
+	   tmp = compute_hex(&addr, &buf[0], uval, (*fmt == 'p') ? true : false);
+	   break;
+         default:
+            *addr = *fmt;
+            count++;
+            goto next;
+         }
+         while (*tmp)
+         {
+            *addr = *tmp++;
+            addr += inc;
+            count++;
+         }
+       next:
+         fmt++;
+      }
+   }
+   va_end (ap);
+   return count;
+}
Index: trunk/kernel/libk/iprintk.c.old
===================================================================
--- trunk/kernel/libk/iprintk.c.old	(revision 1)
+++ trunk/kernel/libk/iprintk.c.old	(revision 1)
@@ -0,0 +1,169 @@
+/*
+   This file is part of MutekP.
+  
+   MutekP is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+  
+   MutekP is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+  
+   You should have received a copy of the GNU General Public License
+   along with MutekP; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+  
+   UPMC / LIP6 / SOC (c) 2007
+*/
+
+/* 
+   revision 1.2.1 2007/11/11 18:54:23 ghassan
+   rename iprintf to __iprintk, it's a copy of iprintf called on system level.
+   
+   stdio of the ghost of libc
+   Developped by Denis Hommais and Frédéric Pétrot
+   $Log: iprintf.c,v $
+   Revision 1.2  2003/07/01 13:40:46  fred
+   Supports the %u and doesnt core anymore on an unrecognized char
+   following a %
+  
+   Revision 1.1.1.1  2002/02/28 12:58:56  disydent
+   Creation of Disydent CVS Tree
+  
+   Revision 1.1  2001/11/22 15:07:36  fred
+   Adding the iprintf function that does the formatting, and removes all
+   the old stuff hanging around.
+  
+   $Id: iprintf.c,v 1.2 2003/07/01 13:40:46 fred Exp $
+   Made up this file to centralize the printf behavior
+*/
+
+#include <stdarg.h>
+#include <libk.h>
+
+/* Handling of the printf internals
+ * Addr is either the buffer or the tty addrs
+ * inc is 0 for a tty and 1 for a buffer
+ * Other arguments are self explanatory
+ */
+
+#define SIZE_OF_BUF 16
+int iprintk (char *addr, int inc, const char *fmt, va_list ap)
+{
+   register char *tmp;
+   int val, i = 0, count = 0;
+   char buf[SIZE_OF_BUF], *xdigit;
+
+   while (*fmt)
+   {
+      while ((*fmt != '%') && (*fmt))
+      {
+	*addr = *fmt++;
+         addr += inc;
+         count++;
+      }
+      if (*fmt)
+      {
+         fmt++;
+         switch (*fmt)
+         {
+         case '%':
+            *addr = '%';
+            addr += inc;
+            count++;
+            goto next;
+         case 'c':
+            *addr = va_arg (ap, int);
+            addr += inc;
+            count++;
+            goto next;
+         case 'd':
+         case 'i':
+            val = va_arg (ap, int);
+            if (val < 0)
+            {
+               val = -val;
+               *addr = '-';
+               addr += inc;
+               count++;
+            }
+            tmp = buf + SIZE_OF_BUF;
+            *--tmp = '\0';
+            do
+            {
+               *--tmp = val % 10 + '0';
+               val /= 10;
+            }
+            while (val);
+            break;
+         case 'u':
+            val = va_arg (ap, unsigned int);
+            tmp = buf + SIZE_OF_BUF;
+            *--tmp = '\0';
+            do
+            {
+               *--tmp = val % 10 + '0';
+               val /= 10;
+            }
+            while (val);
+            break;
+         case 'o':
+            val = va_arg (ap, int);
+            tmp = buf + SIZE_OF_BUF;
+            *--tmp = '\0';
+            do
+            {
+               *--tmp = (val & 7) + '0';
+               val = (unsigned int) val >> 3;
+            }
+            while (val);
+            break;
+         case 's':
+            tmp = va_arg (ap, char *);
+            if (!tmp)
+               tmp = "empty str";
+            break;
+         case 'p':
+         case 'x':
+         case 'X':
+            val = va_arg (ap, int);
+            tmp = buf + SIZE_OF_BUF;
+            *--tmp = '\0';
+            if (*fmt != 'X')
+               xdigit = "0123456789abcdef";
+            else
+               xdigit = "0123456789ABCDEF";
+            do
+            {
+               *--tmp = xdigit[val & 15];
+               val = (unsigned int) val >> 4;
+               i++;
+            }
+            while (val);
+            if (*fmt == 'p')
+               while (i < 8)
+               {
+                  *--tmp = xdigit[0];
+                  i++;
+               }
+            break;
+         default:
+            *addr = *fmt;
+            count++;
+            goto next;
+         }
+         while (*tmp)
+         {
+            *addr = *tmp++;
+            addr += inc;
+            count++;
+         }
+       next:
+         fmt++;
+      }
+   }
+   va_end (ap);
+   return count;
+}
